﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    // custome file structure for Assist

    public class Structure
    {
        // Region for all USA structure

        #region usaFile

        //USA main format structure
        public struct UsaFile
        {
            public char[] header; // usa header
            public UInt64 fileSize; // file size
            public UInt64 version; // vrsion
            public string userName; // user nam of the person
            public string step; // step of the model
            public string comments; // cooments about file
            public UInt32 numberOfGeo; // number of geomtries
            public UInt64[] geoOffSets; // place in binary file to reach geo data 
            public Geometry[] geometries; // geometry of the 3D model
            public UInt32 numOfAp; // number of app
            public UInt64[] apOffSet; //place in binary file to reach app data
            public Apearance[] apearances; // aparance of the 3D model
            public UInt64 numOfCam; // number of cam
            public UInt64[] camOffset; // place in binary file to reach cam data
            public Camera[] cam; // camera data
            public UInt64 numOfLight; // number of lights
            public UInt64[] lightOffSet; // place in binary file to reach light data
            public Light[] light; // light data
            public UInt64 numOfAnime; // number of animes
            public UInt64[] animeOffSet; // place in binary file to reach anime data
            public Animation[] animations; // animation of the 3D model 
        }

        // Encording geometry of the 3D model
        public struct Geometry
        {
            public UInt64 serfaceID; // ID of the each triangle serface
            public UInt32 point1; // first vertx of the triangle
            public UInt32 point2; // second vertex of the triangle
            public UInt32 point3; // third vertex of the triangle
            public UInt32 nPoint1; // first vertex of the outword normal vector
            public UInt32 nPoint2; // second vertex of the outword normal vector
        }

        // storing apearance of the 3D model
        public struct Apearance
        {
            public UInt64 serfaceID2; //ID of the each serface
            public UInt64 aColor; // colour of the ech serface
            public UInt64 texture; // texture of the serface
            public UInt64 matirial; // material of ther serface
        }

        // Scene information
        public struct Camera
        {
            public UInt32 magPoint; // magnification point of the camera
            public UInt32 location; // Location of the camra
            public UInt32 direction; // direction of thee camera
            public UInt32 up; //which dirction is the up 
        }
        public struct Light
        {
            public UInt32 lLoction; // direction of the light source
            public UInt32 lColour; // colour of the source light
            public UInt32 intensity; // intencity of the light source
        }

        //Encording Animation
        public struct Animation
        {
            public UInt32 rotation; // rotation of the virtual bone
            public UInt32 scale; // scale of the bone
            public UInt32 shear; // shear of the bone
            public UInt32 translation; // translation of th bone
        } 

        #endregion

    }
}
