﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    public static class StructureTools
    {
        #region usafFile
        // Take string from text file and convert it to USA structure
        public static Structure.UsaFile StringArrayToUsaFile(string[] Strings)
        {
            // Make new USA file
            Structure.UsaFile usa = new Structure.UsaFile();

            usa.userName = Strings[0];  // set user name
            usa.step = Strings[1];  // set step
            usa.comments = Strings[2];  // set comments

            usa.numberOfGeo = UInt32.Parse(Strings[3]);
            Structure.Geometry[] geometries = new Structure.Geometry[usa.numberOfGeo];
            for (int i = 4; i < usa.numberOfGeo; i++)
            {
                string[] values = Strings[4].Split(',');
                geometries[4].serfaceID = UInt64.Parse(values[0]);
                geometries[4].point1 = UInt32.Parse(values[1]);
                geometries[4].point2 = UInt32.Parse(values[2]);
                geometries[4].point3 = UInt32.Parse(values[3]);
                geometries[4].nPoint1 = UInt32.Parse(values[4]);
                geometries[4].nPoint2 = UInt32.Parse(values[5]);
            }
                usa.geometries = geometries;
           

            usa.numOfAp = UInt32.Parse(Strings[5]);
            Structure.Apearance[] apearances = new Structure.Apearance[usa.numOfAp];
            for (int i = 4; i < usa.numOfAp; i++)
            {
                string[] values1 = Strings[5].Split(',');
                apearances[6].serfaceID2 = UInt64.Parse(values1[0]);
                apearances[6].aColor = UInt32.Parse(values1[1]);
                apearances[6].texture = UInt32.Parse(values1[2]);
                apearances[6].matirial = UInt32.Parse(values1[3]);
            }
            usa.apearances = apearances;

            usa.numOfCam = UInt64.Parse(Strings[7]);
            Structure.Camera[] cameras = new Structure.Camera[usa.numOfCam];
            string[] values2 = Strings[4].Split(',');
            cameras[8].magPoint = UInt32.Parse(values2[0]);
            cameras[8].location = UInt32.Parse(values2[1]);
            cameras[8].direction = UInt32.Parse(values2[2]);
            cameras[8].up = UInt32.Parse(values2[3]);
            usa.cam = cameras;

            usa.numOfLight = UInt64.Parse(Strings[9]);
            Structure.Light[] lights = new Structure.Light[usa.numOfLight];
            string[] values3 = Strings[4].Split(',');
            lights[10].lLoction = UInt32.Parse(values3[0]);
            lights[10].lColour = UInt32.Parse(values3[1]);
            lights[10].intensity = UInt32.Parse(values3[2]);
            usa.cam = cameras;

            usa.numOfAnime = UInt64.Parse(Strings[11]);
            Structure.Animation[] animations = new Structure.Animation[usa.numOfAnime];
            string[] values4 = Strings[4].Split(',');
            animations[12].rotation = UInt32.Parse(values4[0]);
            animations[12].scale = UInt32.Parse(values4[1]);
            animations[12].shear = UInt32.Parse(values4[2]);
            animations[12].translation = UInt32.Parse(values4[3]);
            usa.animations = animations; 

            usa.version = 1; // set file specific data

            // set header
            char[] header = { 'U', 'S', 'A' };
            usa.header = header;

           // UInt64 offset = (UInt64)(usa.header.Length + 8 + 8 + usa.userName.Length + 1 + usa.step.Length + 1 + usa.comments.Length + 1);

            //calculate the starting offset
            UInt64 offset = (UInt64) (usa.header.Length + 8 + 8 + usa.userName.Length + 1 + usa.step.Length + 1 + usa.comments.Length + 1 + 8 + usa.geoOffSets.Length * 8 + 8
                + usa.apOffSet.Length * 8 + 8 + usa.camOffset.Length * 8 + 8 + usa.lightOffSet.Length * 8 + 8 + usa.animeOffSet.Length * 8);

            // graully st and increse bytes

            UInt64[] offsets1 = new UInt64[usa.numberOfGeo];
            for (int i = 0; i < offsets1.Length; i++)
            {
                // set initial value
                offsets1[i] = offset;

                // increment
                offset += (UInt64)(8 + 4 + 4 + 4 + 4 + 4);
            }

            UInt64[] offsets2 = new UInt64[usa.numOfAp];
            for (int i = 0; i < offsets2.Length; i++)
            {
                // set initial value
                offsets2[i] = offset;

                // increment
                offset += (UInt64)(8 + 8 + 8 + 8);
            }

            UInt64[] offsets3 = new UInt64[usa.numOfCam];
            for (int i = 0; i < offsets3.Length; i++)
            {
                // set initial value
                offsets3[i] = offset;

                // increment
                offset += (UInt64)(4 + 4 + 4 + 4);
            }

            UInt64[] offsets4 = new UInt64[usa.numOfLight];
            for (int i = 0; i < offsets4.Length; i++)
            {
                // set initial value
                offsets4[i] = offset;

                // increment
                offset += (UInt64)(4 + 4 + 4);
            }

            UInt64[] offsets = new UInt64[usa.numOfAnime];
            for (int i = 0; i < offsets.Length; i++)
            {
                // set initial value
                offsets[i] = offset;

                // increment
                offset += (UInt64)(4 + 4 + 4 + 4);
            } 

            //set file size
            usa.fileSize = offset;

            // return the final data
            return usa;
        }

        // save the usa fil to a bin to be rad later

        public static byte[] UsaFileToBytes(Structure.UsaFile usa)
        {
            // make memory stream
            MemoryStream o = new MemoryStream();

            // make binary write to write stream
            BinaryWriter bw = new BinaryWriter(o);

            bw.Write(usa.header);
            bw.Write(usa.fileSize);
            bw.Write(usa.version);
            bw.Write(usa.userName);
            bw.Write(usa.step);
            bw.Write(usa.comments);

            bw.Write(usa.numberOfGeo);
            foreach (UInt64 offset in usa.geoOffSets)
            {
                bw.Write(offset);
            }
            foreach (Structure.Geometry Geometry in usa.geometries)
            {
                bw.Write(Geometry.serfaceID);
                bw.Write(Geometry.point1);
                bw.Write(Geometry.point2);
                bw.Write(Geometry.point3);
                bw.Write(Geometry.nPoint1);
                bw.Write(Geometry.nPoint2);

            }

            bw.Write(usa.numOfAp);
            foreach (UInt64 offset in usa.apOffSet)
            {
                bw.Write(offset);
            }
            foreach (Structure.Apearance Apearance in usa.apearances)
            {
                bw.Write(Apearance.serfaceID2);
                bw.Write(Apearance.aColor);
                bw.Write(Apearance.texture);
                bw.Write(Apearance.matirial);
               
                         
            }

            bw.Write(usa.numOfCam);
            foreach (UInt64 offset in usa.camOffset)
            {
                bw.Write(offset);
            }
            foreach (Structure.Camera Camera in usa.cam)
            {
                bw.Write(Camera.magPoint);
                bw.Write(Camera.location);
                bw.Write(Camera.direction);
                bw.Write(Camera.up);
                
            }

            bw.Write(usa.numOfLight);
            foreach (UInt64 offset in usa.lightOffSet)
            {
                bw.Write(offset);
            }
            foreach (Structure.Light Light in usa.light)
            {
                bw.Write(Light.lLoction);
                bw.Write(Light.lColour);
                bw.Write(Light.intensity);
            }

            bw.Write(usa.numOfAnime);
            foreach (UInt64 offset in usa.animeOffSet)
            {
                bw.Write(offset);
            }
            foreach (Structure.Animation Animation in usa.animations)
            {
                bw.Write(Animation.rotation);
                bw.Write(Animation.scale);
                bw.Write(Animation.shear);
                bw.Write(Animation.translation);

            } 

            // return final bytes
            return o.ToArray();
        }
        #endregion
    }
}
